
module BGSketchup_RBZ_maker
	class RBZ_maker
		Sketchup::require 'BGSketchup_RBZ_maker/RBZ_Localization'
		extend BGSketchup_RBZ_maker
		
		@encrypted_files=[]
		
		#WINDOW MANAGEMENT
		def self.show_hide_window
			#On affiche la fenêtre
				if @my_dialog==nil 
					# On créé la boîte de dialogue    
						@my_dialog = UI::WebDialog.new("RBZ maker "+BGSketchup_RBZ_maker_extension.version, false, "BGSketchup_RBZ_maker" , 300, 320, 200, 200, true)
					# On affiche la boîte de dialogue
						html_path = File.join(File.dirname(__FILE__), "Html", "RBZ_Main.html")
						@my_dialog.set_file(html_path)
						@my_dialog.show()
						@my_dialog.set_background_color(@my_dialog.get_default_dialog_color)
						@my_dialog.set_on_close{ @my_dialog=nil; }
						@my_dialog.set_size(900,350)

					# Gestion des actions générées par la boîte de dialogue
						@my_dialog.add_action_callback("get_data") do |web_dialog,action_name|
							puts action_name
							action_name=bgSketchup_to_UTF8(action_name)
							action_name.gsub!("²&é-è_çà","'")  if action_name!=nil
							if action_name.index("(")!=nil then
								action=action_name[0..action_name.index("(")-1]
								parameters=action_name[action.length+1..action_name.length-2]
								parameter=parameters.split(";")
								action_name=action
							end
							
							case action_name
								when "start" then self.start
								when "select" then self.select(parameters.to_i)
								when "encrypt" then self.encrypt(parameters.to_i)
								when "generate" then self.generate
								when "select_file" then self.select_file(parameters.to_i)
								when "bgSketchup_erreur_script" then bgSketchup_erreur_script(parameter)
							
							end
						end
				end
		end
		
		def self.list_extensions
			@extensions=[]
			for extension in Sketchup.extensions
				@extensions.push extension
			end
		end
			
		def self.show_list_extensions
			self.list_extensions
			js= "liste=document.getElementById('list_extensions');"
			js+= "liste.length=0;"
			for e in 0..@extensions.length-1
				extension=@extensions[e]
				js+= "liste.options[liste.length] = new Option('"+bgSketchup_to_java_for_HTML(extension.name).to_s+"', '"+e.to_s+"');"
			end
			js+="document.getElementById('version').innerHTML='';"
			bgSketchup_execute_script(@my_dialog,js,BGSketchup_RBZ_maker_extension.version)
		end
		
		def self.select(index)
			@encrypted_files=[]
			extension=@extensions[index]
			@extension_name=extension.name
			#Show version
				js="document.getElementById('version').innerHTML='"+bgSketchup_to_java_for_HTML(extension.version).to_s+"';"
			
			#Show files
				@file_list=self.list_files(extension)
				js+= "liste=document.getElementById('list_files');"
				js+= "liste.length=0;"
				if @file_list!=nil then
					for file in @file_list
						js+="liste.options[liste.length] =new Option('"+bgSketchup_to_java_for_HTML(file[0]).to_s+"','"+bgSketchup_to_java_for_HTML(file[1]).to_s+"');"
					end
				end
			
			#Propose file name
				path=File.dirname(extension.extension_path)
				base=File.basename(extension.extension_path,".*")+" "+@extensions[index].version+".rbz"
				nom=File.join(path,base)
				js+= "liste=document.getElementById('path_name').value='"+path.to_s+"';"
				js+= "liste=document.getElementById('file_name').value='"+base.to_s+"';"
			
			#Execute script
				bgSketchup_execute_script(@my_dialog,js,BGSketchup_RBZ_maker_extension.version)
			
			#Mark file to be encrypt
				self.mark_files_to_be_encrypted
		end
		
		def self.list_files(extension)
			list=[]
			chemin=extension.extension_path
			list.push [File.basename(chemin),chemin]
			base=File.basename(chemin, ".*" )
			path=File.join(File.dirname(chemin),base)
			
			#path=Sketchup.find_support_file("Plugins")
			Dir.glob(path+"/**/*.*") do |my_file| # note one extra "*"
				list.push [BGSketchup_creer_lien_relatif(my_file,chemin),my_file]
				
			end
			return list
		end
		
		def self.generate
			index=@my_dialog.get_element_value("list_extensions").to_i
			if index!=0 then
				extension=@extensions[index]
				nom_complet=File.join(@my_dialog.get_element_value("path_name"),@my_dialog.get_element_value("file_name"))
				self.generate_rbz(nom_complet,@file_list)
				if File.exist?(nom_complet) then
					UI.messagebox "RBZ created !"
				else
					UI.messagebox "An error occured !"
				end
			end
		end
		
		def self.generate_rbz(zipfile_name, input_filenames)
			#Get list of file to encrypt
				list_to_be_encrypted=self.list_files_to_encrypt

			#Check if file exist
				if File.exist?(zipfile_name) then
					reponse=UI.messagebox("File already exists, do you want to replace it ?",MB_YESNO)
					if reponse==IDYES then
						File.delete(zipfile_name)
					else
						return nil
					end
				end
				
			require 'rubygems'
			require 'zip'
			
			file_to_be_deleted=[]

			Zip::File.open(zipfile_name, Zip::File::CREATE) do |zipfile|
				input_filenames.each do |filename|
					if File.exist?(filename[1]) then
						if list_to_be_encrypted.index(filename[1])==nil then #Zip the file without encryption
							# Two arguments:
							# - The name of the file as it will appear in the archive
							# - The original file, including the path to find it
							zipfile.add(filename[0], filename[1])
						else #We must encrypt before
							file1=self.scramble([filename[1]])[0]
							file0=File.join(self.repertoire(filename[0]),File.basename(filename[0], ".*")+".rbs")
							file0=file0[1..-1] if file0[0]==File.join('','')
							zipfile.add(file0, file1)
							file_to_be_deleted.push file1
						end
					else
						 #File don't exist
						UI.messagebox "One file missing : process stopped !"
						return nil
					end
				end
			end
			
			#Delete rbs files			
				for file in file_to_be_deleted
					File.delete(file)
				end
		end
		
		def self.repertoire(filename)
			if File.dirname(filename)=="." then
				return ''
			else
				return File.dirname(filename)
			end
		end
		
		def self.start
			@my_dialog.set_background_color(@my_dialog.get_default_dialog_color)
			self.load_default_options
			self.load_options
			self.show_list_extensions
			@option_usage+=1
			self.stats_incrementer_compteur
			#UI.messagebox self.scramble(["C:/Users/Benoit/AppData/Roaming/SketchUp/SketchUp 2015/SketchUp/Plugins/BGSketchup_RBZ_maker/Copie de RBZ_maker.rb"])
		end
		
		#ENCRYPTION
			#@encrypted_files is an array of index (from @file_list) that contains files to be encrypt
			def self.select_file(index)
				if @file_list[index][1].split(".")[-1].upcase=="RB" then
					if @encrypted_files.index(index)!=nil then
						js= "document.getElementById('encryption').style.display='inline';document.getElementById('encrypt').disabled=false;document.getElementById('encrypt').checked=true;"
					else
						js= "document.getElementById('encryption').style.display='inline';document.getElementById('encrypt').disabled=false;document.getElementById('encrypt').checked=false;"
					end
				else
					js= "document.getElementById('encryption').style.display='none';document.getElementById('encrypt').disabled=true;document.getElementById('encrypt').checked=false;"
				end
				bgSketchup_execute_script(@my_dialog,js,BGSketchup_RBZ_maker_extension.version)
			end
			
			def self.encrypt(index) #Mark selected file to be encrypted + save the selection
				if @encrypted_files.index(index)==nil then #If file is not already marked to be encrypted
					@encrypted_files.push index.to_i
					self.save_file_to_encrypt(@my_dialog.get_element_value("list_files"))
					js= "liste=document.getElementById('list_files');"
					js+="liste.options["+index.to_s+"].style.backgroundColor = 'red';"
					bgSketchup_execute_script(@my_dialog,js,BGSketchup_RBZ_maker_extension.version)
				else #If file is already marked to be encrypted
					self.remove_file_to_encrypt(@my_dialog.get_element_value("list_files"))
					@encrypted_files.delete(index.to_i)
					js= "liste=document.getElementById('list_files');"
					js+="liste.options["+index.to_s+"].style.backgroundColor = '';"
					bgSketchup_execute_script(@my_dialog,js,BGSketchup_RBZ_maker_extension.version)
				end
			end
			
			def self.list_files_to_encrypt
				list=[]
				for index in @encrypted_files
					list.push @file_list[index][1]
				end
				return list
			end
			
			def self.scramble(filenames)
				#system('C:\toto\SketchUpRubyScramblerWindows.exe','C:\toto\test.rb')
				rbs_files=[]
				for filename in filenames
					#Encrypt file, delete not encrypt file and return the file name of encrypted file
					if Sketchup.platform.to_s== "platform_win" then
						commande=File.join(Sketchup.find_support_file("Plugins"),"BGSketchup_RBZ_maker","SketchUpRubyScramblerWindows.exe")
					else
						commande=File.join(Sketchup.find_support_file("Plugins"),"BGSketchup_RBZ_maker","scrambler.app")
					end
					
					if system(commande,filename.to_s)!=nil then
						#ok
						rbs_files.push File.join(self.repertoire(filename),File.basename(filename, ".*")+".rbs")
					else
						#Error : stop and return nil
						return nil
					end
				end
				return rbs_files
			end
			
			#[{"a"=>1,"b"=>11},{"a"=>2,"b"=>2},{"a"=>1,"b"=>2}].index{|x| x['a']==1}
			def self.save_file_to_encrypt(filename) 				#Add the filename to files list to be encrypted
				index=@global_file_to_be_encrypt.index{|x| x['name']==@extension_name}
				if (index==nil || index==false) then
					#We add the extension and the file
					@global_file_to_be_encrypt.push( {'name'=>@extension_name, 'files'=>[filename]})
				else
					#We add the file
					@global_file_to_be_encrypt[index]['files'].push(filename)
				end
				self.save_options
			end
			def self.remove_file_to_encrypt(filename) 				#Remove the filename from files list to be encrypted
				index=@global_file_to_be_encrypt.index{|x| x['name']==@extension_name}
				if (index==nil || index==false) then
					#Extension not found !! Should be an error
					return nil
				else
					#We remove the file
					@global_file_to_be_encrypt[index]['files'].delete(filename)
					#Delete completely the extension from list if no file has to be encrypted
					if @global_file_to_be_encrypt[index]['files'].length==0 then
						@global_file_to_be_encrypt.delete_at(index)
					end
				end
				self.save_options			
			end
			def self.get_files_to_encrypt(name_of_extension)
				p index=@global_file_to_be_encrypt.index{|x| x['name']==@extension_name}
				if index!=nil then
					return @global_file_to_be_encrypt[index]['files']
				else
					return nil
				end
			end
			def self.mark_files_to_be_encrypted
				if (list=self.get_files_to_encrypt(@extension_name))!=nil then
					js=""
					@encrypted_files=[]
					for file in list
						index=0
						for f in @file_list
							if f[1]==file then
								js+="document.getElementById('list_files').options["+index.to_s+"].style.background='red';"
								@encrypted_files.push index.to_i
							end
							index+=1
						end
					end
					bgSketchup_execute_script(@my_dialog,js,BGSketchup_RBZ_maker_extension.version)
				else
					return nil
				end
				
			end
		
		#STATISTIQUES
			def self.stats_incrementer_compteur
				#On envoie les données
				bgSketchup_add_stats(@my_dialog, BGSketchup_RBZ_maker_extension, [bgSketchup_Temp_folder_is_plugin_folder?,@option_usage.to_s])
			end
		#OPTIONS
			def self.save_options
				file_name=File.join(bgSketchup_getTempFolder,"BGSketchup_RBZ_maker.ini")
				File.delete(file_name) if File.exists?(file_name)
				file=File.new(file_name, "w")
				file.puts("option_check_for_updates")
				file.puts(@option_check_for_updates)
				file.puts("option_change_language")
				file.puts(@option_change_language)
				file.puts("option_language")
				file.puts(@option_language)
				file.puts("option_usage")
				file.puts(@option_usage)
				file.puts("option_prompt_my_language_added")
				file.puts(@option_prompt_my_language_added)
				
				#Save encrypt files
					for f in @global_file_to_be_encrypt
						file.puts "Encrypted_files"
						file.puts f['files'].length
						file.puts f['name']
						for ff in f['files']
							file.puts ff
						end
					end
					file.puts "Encrypted_files-fin" if @global_file_to_be_encrypt.length!=0
					file.puts "toto" if @global_file_to_be_encrypt.length!=0
				file.close
			end
			def self.load_options
				#Load default option in case one option is missing
				self.load_default_options
				@global_file_to_be_encrypt=[]
				file_name=File.join(bgSketchup_getTempFolder,"BGSketchup_RBZ_maker.ini")
				if File.exists?(file_name)==true then 	#File exist
					file = File.open(file_name, "r")
					while !file.eof?
						option_name=file.readline.gsub(10.chr,"").gsub(13.chr,"")
						option_value=file.readline.gsub(10.chr,"").gsub(13.chr,"")

						@option_check_for_updates=(option_value=="true") ? true : false if option_name=="option_check_for_updates"
						@option_change_language=(option_value=="true") ? true : false if option_name=="option_change_language"
						@option_language=option_value if option_name=="option_language"
						@option_usage=option_value.to_i if option_name=="option_usage"
						@option_prompt_my_language_added=(option_value=="true") ? true : false if option_name=="option_prompt_my_language_added"
						if option_name=="Encrypted_files" then
							length=option_value.to_i
							name=file.readline.gsub(10.chr,"").gsub(13.chr,"")
							files=[]
							for i in 1..length
								files.push file.readline.gsub(10.chr,"").gsub(13.chr,"")
							end
							@global_file_to_be_encrypt.push( {'name'=>name, 'files'=>files})
						end
					end
					#UI.messagebox @global_file_to_be_encrypt.to_s
					file.close
				else												#File doesn't exist
					#Save Default options
					save_options
				end
			end
			def self.load_default_options	#Default options
				@option_check_for_updates=true
				@option_change_language=false
				if @availableLanguages.index(Sketchup.os_language)!=nil
					@option_language=Sketchup.os_language
				else
					@option_language="en"
				end
				@option_usage=0
				@option_prompt_my_language_added=false
			end
		
		#MENUS
			def self.creation_menus			#Add Plugins menu and toolbar
				menu=BGSketchup_Ajouter_Submenu("BGSketchup")
				menu.add_item(@translation_menu_name) { self.show_hide_window }
			end
			def self.creation_toolbar
				bgSketchup_creer_toolbar("RBZ_maker","BGSketchup_RBZ_maker::RBZ_maker.show_hide_window","BGSketchup_RBZ_maker/Html/large_toolbar.png","BGSketchup_RBZ_maker/Html/large_toolbar.png","BGSketchup_RBZ maker","Create RBZ from your extensions","Create RBZ from your extensions")
			end
			
		#PLUGIN LOADING
			unless file_loaded?( __FILE__ )
				initialise_localization(false)
				if !File.exists?(File.join(Sketchup.find_support_file("Plugins"), 'BGSketchup_Library.rb')) then
					reponse=UI.messagebox(@translation_library_no_found+@translation_open_link,MB_YESNO)
					if reponse==IDYES then
						status = UI.openURL("http://sketchucation.com/pluginstore?pln=BGSketchup_Library")
					end
				else
					Sketchup::require 'BGSketchup_Library'
					extend BGSketchup_Library
					if bgSketchup_version_library>=Required_library_version then
						self.load_options
						initialise_localization(false)
						self.creation_menus
						self.creation_toolbar
					else
						self.load_options
						initialise_localization(false)
						txt=@translation_library_not_good_version+10.chr
						txt+="(Required : "+bgSketchup_version_library_string(Required_library_version)+", current : "+bgSketchup_version_library_string(nil)+")"+10.chr
						txt+=@translation_open_link
						reponse=UI.messagebox(txt,MB_YESNO)
						if reponse==IDYES then
							bgSketchup_update_manager
						end
					end
				end
			end
	end
	RBZ_maker.new
end #module